package service

import (
	dbModel "taskcenter/model/db"
	"time"

	log "github.com/sirupsen/logrus"
)

func (s *Service) CheckTask(taskId int, userId string) (exist, done bool, expired bool, err error) {
	exist = true
	task, err := s.d.GetTaskDetail(taskId)
	if err != nil {
		log.WithError(err).Error("get task error")
		return
	}
	if task == nil {
		exist = false
		return
	}
	log.Debugf("task: %+v", task)

	// 超出时间后只查询不再更新状态
	if int64(task.Start) > time.Now().Unix() || int64(task.End) < time.Now().Unix() {
		expired = true
	}

	done, err = s.d.IsTaskDone(taskId, userId)
	if err != nil {
		log.WithError(err).Error("is task done error")
		return
	}

	return
}

func (s *Service) GetTaskDetail(taskId int) (task *dbModel.Task, err error) {
	task, err = s.d.GetTaskDetail(taskId)
	if err != nil {
		log.WithError(err).Error("get task error")
	}
	return
}

func (s *Service) GetTaskResult(taskId int, userId string) (status string, err error) {
	status, err = s.d.GetTaskResult(taskId, userId)
	if err != nil {
		log.WithError(err).Error("get task result error")
	}
	return
}

func (s *Service) SubmitTask(taskId int, userId string, isDailyTask bool) (exist bool, err error) {
	exist, err = s.d.CreateTaskHistory(taskId, userId, isDailyTask)
	if err != nil {
		log.WithError(err).Error("create task history error")
	}
	return
}
